site/apps/childcarts/urls.py
from django.urls import path

from .views import ChildCartListView, ChildCartDetailView

app_name = 'childcarts'

urlpatterns = [
    path('childcart-list/',
         ChildCartListView.as_view(),
         name='childcart_list'),
    path('',
         ChildCartListView.as_view(),
         name='childcart_list'),
    path('<category_name>',
         ChildCartListView.as_view(),
         name='childcart_category'),
    path('<int:cart_id>/<cart_slug>/',
         ChildCartDetailView.as_view(),
         name='childcart_detail'),

]

site/base/urls.py
"""site URL Configuration"""

from django.conf.urls import include, handler404, \
    handler500, handler403, handler400
from django.urls import path
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
admin.autodiscover()

from apps.pages.views import ErrorPageView


urlpatterns = i18n_patterns(
    path('admin/', admin.site.urls),
    path('clothes/', include('apps.clothes.urls')),
    path('products/', include('apps.products.urls', namespace='products')),
    path('childcarts/', include('apps.childcarts.urls', namespace='childcarts')),
    path('', include('apps.pages.urls')),
)

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# views to display the corresponding error pages
handler404 = ErrorPageView.as_view(error_code='404')
handler403 = ErrorPageView.as_view(error_code='403')
handler400 = ErrorPageView.as_view(error_code='400')
handler500 = ErrorPageView.as_view(error_code='500')

site/apps/childcarts/models.py
from django.db import models

from apps.products.models import Product


class ChildCarts(Product):
    '''
    ChildCarts is a base category which will store different types of carts
    e.g. Barnevogne, kombi/duovogn, klapvogn, lobejogere,
    '''
    age_group = models.CharField(max_length=200)
    # l/w/h are declared as CharFields because they have to store below values
    # Total bredde på stel med hjul: 56 cm
    # Stel sammenklappet uden hjul: 84 / 47 / 18 cm
    # Barnevognskasse (indvendig): 98 / 38 / 23 cm
    # Styrets højde (laveste - højeste): 92 - 116 cm
    length = models.CharField(max_length=200, blank=True, null=True)
    width = models.CharField(max_length=200, blank=True, null=True)
    height = models.CharField(max_length=200, blank=True, null=True)
    # Example values for weight are below
    # Stel inkl. Hjul: 10,8 kg
    # Barnevognskasse : 6.7 kg
    weight = models.CharField(max_length=200, blank=True, null=True)

site/apps/childcarts/views.py
from django.shortcuts import render, get_object_or_404
from django.views.generic import ListView, DetailView

from apps.products.models import Category
from .models import ChildCarts

class ChildCartListView(ListView):
    '''
        Displays a list of all available childcarts
    '''
    def get(self, request, *args, **kwargs):
        # all child carts have childcart as parent category. Therefore, we will
        # filter all categories which have childcart as parent
        categories = Category.objects.filter(parent_category__name__iexact='childcarts')
        context = {
            'childcart_list': ChildCarts.objects.filter(available=True),
            'category': None,
            'categories': categories,
        }
        return render(request, 'childcarts/childcart_list.html', context)


class ChildCartDetailView(DetailView):
    '''
        Display the details of a selected child cart
    '''
    def get(self, request, *args, **kwargs):
        product = get_object_or_404(ChildCarts,
                                    id=kwargs['cart_id'],
                                    slug=kwargs['cart_slug'],
                                    available=True)
        # cart_product_form = CartAddProductForm()
        return render(request,
                      'childcarts/childcart_detail.html',
                      {
                          'product': product,
                          # 'cart_product_form': cart_product_form
                      }
                      )

site/templates/childcarts/childcart_detail.html
{% extends "home_base.html" %}
{% load static %}

{% block title %}
  {{ product.name }}
{% endblock %}

{% block content %}
  <div class="product-detail">
    <img src="{% if product.image %}{{ product.image.url }}{% else %}{% static 'images/no_image.png' %}{% endif %}">
    <h1>{{ product.name }}</h1>
    <h2><a href="{{ product.category.get_absolute_url }}">{{ product.category }}</a></h2>
    <p class="price">${{ product.price }}</p>
    {{ product.description|linebreaks }}
  </div>
{% endblock %}

site/templates/childcarts/childcart_list.html
{% extends "home_base.html" %}
{% load static %}

{% block title %}
  {% if category %}{{ category.name }}{% else %}Child Carts{% endif %}
{% endblock %}

{% block content %}
<div class="row">
  <div class="col-sm-12">
    <h1>{% if category %}{{ category.name }}{% else %}Child Carts{% endif %}</h1>
  </div>
  <div id="sidebar" class="col-sm-3">
    <h3>Categories</h3>
    <ul>
      <li {% if not category %}class="selected"{% endif %}>
        <a href="{% url 'childcarts:childcart_list' %}">All</a>
      </li>
      {% for c in categories %}
        <li {% if category.slug == c.slug %}class="selected"{% endif %}>
          <a href="{% url 'childcarts:childcart_category' c.name %}">{{ c.name }}</a>
        </li>
      {% endfor %}
    </ul>
  </div>
  {% if childcart_list %}
  {% for cart in childcart_list %}
    <div class="item col-sm-3">
      <a href="{{ cart.get_absolute_url }}">
        <img class="img-fluid" src="{% if cart.image %}{{ cart.image.url }}{% else %}
        {% static 'img/no_image.png' %}{% endif %}">
      </a>
      <a href="{% url 'childcarts:childcart_detail' cart.id cart.slug %}">{{ cart.name }}</a><br>
      ${{ cart.price }}
    </div>
  {% endfor %}
  {% endif %}
</div>
{% endblock %}